/*
*****************************************************************************
**
**      Project     : Helmkamera
**
**      Component   : uC (ATmega32)
**
**      Modulename  : System
**
**      Filename    : interrupts.c
**
**      Abstract    : Enthlt alle Interuptroutinen
**                    
**                    
**
**      Date        : 06.04.2005
**
**      Fertigstell :
**
**      Progs       : ICC_AVR 6.26B
**
**      Anderungen  :
**

/*
**---------------------------------------------------------------------------
**  Timer_1 OCRA ... schaltet IRQ fr LANCsenden kurz vor erwartetem Start ein
**  
**  --Parameters: None
**  --Returns:  None
**---------------------------------------------------------------------------
*/
void timer1_OCRA_isr(void)
{
   CLEARBIT(TIMSK,OCIE1A);  		//comperainterrupt aus										 
   SETBIT(EIFR,INTF2);			 //Flag lschen
   SETBIT(EIMSK,INT2);				//Interrupt ein 			 
}  

/*
**---------------------------------------------------------------------------
**  Timer_1 overflow interrupt routine
**  zeigt lancfehler an
**  --Parameters: None
**  --Returns:  None
**---------------------------------------------------------------------------
*/
void timer1_ovf_isr(void)
{
lancFrameStat = 0;
}


void uart1_rx_isr(void)
{

u08 UDRtemp = UDR1;
ltime = TCNT1L;
ltime |= (u16) TCNT1H<<8;	   		    //Timer1 einlesen




TCNT1H = 0;  TCNT1L = 0;		//Timer1 reseten

if (lancFrameStat == 0)
   {lancFrameStat = 1;
   return;
   }

if (ltime > 2300 && ltime < 4000 && lancFrameStat == 1)    //  8 ms < t < 12 ms
   {lancFrameStat = 2;	  		   //Framestart erkannt
   	return;		  				   	//gltig erst beim 2. erkennen
   }
    
if (ltime > 2300 && ltime < 4000)    //  8 ms < t < 12 ms
   {lancFrameStat = 3;	  		   //Framestart erkannt
   	lancbuff[0] = ~UDRtemp;		   //erste Byte (0) einlesen
	xlancBytePos = 1;			   //Zhler auf zweites
	
   SETBIT(EIFR,INTF2);			    //Flag lschen
   SETBIT(EIMSK,INT2);				//Interrupt ein 		
	return;
   }

if (lancFrameStat == 3 && ltime < 350) // letztes Byte maximal 1500 us vergangen
   {
   lancbuff[xlancBytePos] = ~UDRtemp;
   xlancBytePos++;
   
   SETBIT(EIFR,INTF2);			    //Flag lschen
   SETBIT(EIMSK,INT2);				//Interrupt ein 		
 
   }

if (xlancBytePos > 7)
   {   
   lancFrameStat = 2;	  			 //Frameende !! = 2
   xlancBytePos = 0;
   
   SETBIT(TIFR,OCF1A);				 //OCR int flag lschen
   SETBIT(TIMSK,OCIE1A);			 //Counter 1 Compareinterrupt fr sendestarterkennung 
  }
if (lancFrameStat == 3 && ltime >350)
   lancFrameStat = 1;  	  			 //Framefehler == 1
   
//if (TESTBIT(UCSR1A,FE1))
//   lancFrameStat = 1;   



}


/*
**---------------------------------------------------------------------------
**  External Int 2
** 
**  --Parameters: None
**  --Returns:  None
**---------------------------------------------------------------------------
*/
void int2_isr(void)
{
if (xlancBytePos <4) UDR1 = ~lancsendbuff[xlancBytePos];
CLEARBIT(EIMSK,INT2);

}
