/*
*****************************************************************************
**
**      Project     : Helmkamera
**
**      Component   : uC (ATmega128)
**
**      Modulename  : System
**
**      Filename    : lanc.c
**
**      Abstract    : Lanc Kommunikation
**                    
**                    
**
**      Date        : 06.04.2005
**
**      Fertigstell :
**
**      Progs       : ICC_AVR 6.26B
**
**      Anderungen  :
**
**
*****************************************************************************
*/
//Includes
#include "globals.h"
#include "hoehe.h"
#include "spi.h"
#include "functions.h"
#include "interrupts.h"


//Globale Vars
char lancFrameStat; //Frame detektion Status ... bei >2 = Frame gelockt
char xlancBytePos;
u08 lancbuff[8];   //Datenbuffer fr Lanc
u08 lancsendbuff[4]={0x00,0x00,00,00};
u16 ltime;

u08 TREClatch;
u08 recEin;

//Hauptsteuerung in den Interrupts mittels USART hier nur Bufferbeschreibung !!

//#define PREC PINC
//#define TREC 4
//#define PRECLED PORTB
//#define RECLED 0

/*
**---------------------------------------------------------------------------
**  Aufnahmesteuerung
**  
**  --Parameters: None
**  --Returns:  None
**---------------------------------------------------------------------------
*/
void recControl(void)
{
if (TESTBIT(PREC,TREC) && (TREClatch==1))  //Taster nicht gedrckt
   TREClatch= 0;  
   
if (TESTNOTBIT(PREC,TREC) && (TREClatch==0)) //Taster gedrckt
   {TREClatch = 1;
    recEin ^= 0xFF;
   } 

if (recEin == 0)
   {
   lancsendbuff[0]= 0x18;
   lancsendbuff[1]=0x30; //Rec stop
   }
   else
   {
   lancsendbuff[0]= 0x18;
   lancsendbuff[1]=0x3A; //Rec stop
   }   

if (lancbuff[4] == 0x04)  //Kamera nimmt auf !!
   {
   SETBIT(PRECLED,RECLED);
   }


if (lancbuff[4] == 0x02)
   {
   if (system_sec%2)
   	   CLEARBIT(PRECLED,RECLED);
   	   else
	   SETBIT(PRECLED,RECLED);					
   }

if (!lancFrameStat)								//kein Lancempfang
   {
   CLEARBIT(PRECLED,RECLED);
   	   
   }
   
}



